<?php
// archivo: confirmarcompra.php
// objetivo: datos del cliente

// esta pgina es puro proceso de base de datos
// casi no tiene HTML
// Lee el registro de Cliente
// Lee la Cesta
// Lee los ItemCesta (elementos de la cesta)
// Inicia la transaccin
//   Inserta el pedido
//   Inserta los tem del pedido
//   Actualiza las existencias del catlogo
//   Borra los tem de la cesta
//   Borra la Cesta
// Finaliza la transaccin ( si alguna operacin
// de base de datos da error retrocede la transaccin)
// Enva un email al cliente confirmando la compra
// Enva un email a cada proveedor para pedir la reposicin
// Informa en la pgina el resultado de toda la operacin


////////////////////////////////////////////////////
// archivos de inclusin
////////////////////////////////////////////////////

  require '../include/clTablaHTML.php';
  require '../include/partecomun.php';

$tit= "Proceso de confirmacin de la compra ";
?>

<html>
  <head>
    <title><?php echo $tit. "(pgina:".$doc .")" ?></title>
    </head>
    <body>
    <link href="../css/comercio.css"
          rel="stylesheet"
          media="all"
          type="text/css"
           />

<?php

verVariables();

////////////////////////////////////////////////////
// Barra de navegacin del proceso de compra
////////////////////////////////////////////////////
tabNavegaCompra();


////////////////////////////////////////////////////
// Se establece la conexin
////////////////////////////////////////////////////
conectarGuest();

////////////////////////////////////////////////////
// Si no hay cesta activa vuelve al inicio
////////////////////////////////////////////////////
if (!isset($_SESSION['Cesta']))
	redirect("inicio.php");


////////////////////////////////////////////////////
// Si no est en sesin debe autenticarse
////////////////////////////////////////////////////
if (!isset($_SESSION['Cliente']))
    redirect("autenticarse.php");


$cliente= $_SESSION['Cliente'];
$cesta= $_SESSION['Cesta'];


////////////////////////////////////////////////////
// Obtener datos del cliente
////////////////////////////////////////////////////
$strsql =
  "SELECT * FROM Clientes
     WHERE
       ClienteID =".$cliente.";";


// crea el conjunto de resultados
$rcli = $con->query($strsql);

if (!$rcli)
    tratarError("Error en lectura de tabla de clientes", $strsql);

$fcli = $rcli->fetch_assoc();

// detecta el uso de escape en campos alfabticos
if (get_magic_quotes_gpc())  {
   $fcli['Nombre']=stripslashes($fcli['Nombre']);
   $fcli['Apellidos']=stripslashes($fcli['Apellidos']);
   $fcli['EMail']=stripslashes($fcli['EMail']);
   $fcli['PalabraPaso']=stripslashes($fcli['PalabraPaso']);
   $fcli['Direccion']=stripslashes($fcli['Direccion']);
   $fcli['Ciudad']=stripslashes($fcli['Provincia']);
   $fcli['CodigoPostal']=stripslashes($fcli['CodigoPostal']);
   $fcli['Telefono']=stripslashes($fcli['Telefono']);
   $fcli['FAX']=stripslashes($fcli['FAX']);
   $fcli['NumeroTarjeta']=stripslashes($fcli['NumeroTarjeta']);
   $fcli['NombreEntarjeta']=stripslashes($fcli['NombreEntarjeta']);
 }

////////////////////////////////////////////////////
// Obtener datos de la cesta
////////////////////////////////////////////////////

$strsql =
  "SELECT * FROM Cesta
    WHERE
      CestaID =".$cesta.";";


// crea el conjunto de resultados
$rces = $con->query($strsql);

if (!$rces)
   tratarError("Error en lectura de tabla de cesta", $strsql);

$fces = $rces->fetch_assoc();


////////////////////////////////////////////////////
// Obtener datos de los tem de la cesta
////////////////////////////////////////////////////
$strsql =
  "SELECT *   FROM ItemCesta
     JOIN Libros ON ItemCesta.LibroID=Libros.LibroID
     JOIN Proveedores ON Libros.ProveedorID=Proveedores.ProveedorID
     WHERE
       CestaID =".$_SESSION["Cesta"].";";


// crea el conjunto de resultados
$result = $con->query($strsql);

if (!$result)
    tratarError("Error en lectura de tabla de itemcesta", $strsql);



// por claridad y seguridad inicializamos los contadores
$i=0;
$acumPrecio=0;
$acumPeso=0;
$acumIVA= 0;
unset($b);

////////////////////////////////////////////////////////////////
// genera una matriz con todos los tems de la cesta y calcula
// los totales
////////////////////////////////////////////////////////////////
while ($fila = $result->fetch_assoc()) {
  if (get_magic_quotes_gpc()) {
    $b[$i]['LibroID'] = stripslashes($fila['LibroID']);
    $b[$i]['EMailProv'] = stripslashes($fila['EMail']);
  }
  else {
    $b[$i]['LibroID'] = $fila['LibroID'];
    $b[$i]['EMailProv'] = $fila['EMail'];
  }


  $b[$i]['Unidades'] = $fila['CantidadUnidades'];
  $b[$i]['PrecioTotal']  = $fila['Precio']*$fila['CantidadUnidades'];
  $b[$i]['IVATotal']  = $fila['IVA']*$fila['CantidadUnidades'];
  $sumPrecio =  ($fila['Precio']+$fila['IVA'])*$fila['CantidadUnidades'];
  $b[$i]['PrecioVP']  = $sumPrecio;
  $sumPeso = $fila['Peso']*$fila['CantidadUnidades'];
  $b[$i]['PesoTotal'] = $sumPeso;

  $i++;

  // acumulacin de totales
  // suma de peso de los libros
  $acumPeso   += $b[$i]['PesoTotal'];
  // suma de precio sin iva
  $acumPrecio += $b[$i]['PrecioTotal'];
  // suma de IVA
  $acumIVA    += $b[$i]['IVATotal'];


}


// Calcula los gastos de envo
$gastosenvio=tarifaEnvio($acumpeso,$fces['TipoEnvio']);

// Calcula el cargo total
$TotalCargo=$acumPrecio+$acumIVA+$gastosenvio;


////////////////////////////////////////////////////////
// Inicio de la transaccin
////////////////////////////////////////////////////////
$con->autocommit(FALSE);

////////////////////////////////////////////////////////
// Insercin del pedido
////////////////////////////////////////////////////////
$queryInsert =
  "INSERT INTO Pedidos
          (ClienteID,
           FechaPedido,
           Nombre,
           Apellidos,
           EMail,
           Direccion,
           Ciudad,
           Provincia,
           CodigoPostal,
           Telefono,
           FAX,
           TipoTarjeta,
           NumeroTarjeta,
           NombreEntarjeta,
           FechaCaducidad,
           TipoEnvio,
           MedioPago,
           PesoEnvio,
           GastosEnvio,
           PrecioSinIVA,
           IVA,
           TotalCargo,
           Estado,
           FechaEstado)
       VALUES
          (\"".$fcli["ClienteID"]."\",
          now(),
          \"".$fcli["Nombre"]."\",
          \"".$fcli["Apellidos"]."\",
          \"".$fcli["EMail"]."\",
          \"".$fcli["Direccion"]."\",
          \"".$fcli["Ciudad"]."\",
          \"".$fcli["Provincia"]."\",
          \"".$fcli["CodigoPostal"]."\",
          \"".$fcli["Telefono"]."\",
          \"".$fcli["FAX"]."\",
          \"".$fcli["TipoTarjeta"]."\",
          \"".$fcli["NumeroTarjeta"]."\",
          \"".$fcli["NombreEntarjeta"]."\",
          \"".$fcli["FechaCaducidad"]."\",
          \"".$fces["TipoEnvio"]."\",
          \"Tarjeta\",
          \"".$acumPeso."\",
          \"".$gastosenvio."\",
          \"".$acumPrecio."\",
          \"".$acumIVA."\",
          \"".$TotalCargo."\",
          \"En proceso\",
          now());";


if (!$con->query($queryInsert))
       tratarError("Error en insercin de tabla de pedidos:", $queryInsert);


////////////////////////////////////////////////////////
// obtiene el identificador del pedido
////////////////////////////////////////////////////////
$PedidoID=$con->insert_id;


$nok="";
for($i=0;$i<count($b);$i++) {

 	  ////////////////////////////////////////////////////////
	  // Insercin de los tems del pedidos
      ////////////////////////////////////////////////////////
 	  $queryInsert =
 	    "INSERT INTO ItemPedido
 	          (PedidoID,
 	          LibroID,
 	          Unidades,
 	          PesoTotal,
 	          PrecioTotal,
 	          IVATotal,
 	          PrecioVP)
 	        VALUES
 	          (\"".$PedidoID."\",
 	           \"".$b[$i]['LibroID']."\",
 	           \"".$b[$i]["Unidades"]."\",
 	           \"".$b[$i]["PesoTotal"]."\",
 	           \"".$b[$i]["PrecioTotal"]."\",
 	           \"".$b[$i]["IVATotal"]."\",
 	           \"".$b[$i]["PrecioVP"]."\");";


       if (!$con->query($queryInsert))
               tratarError("Error en insercin de tabla de item de pedidos", $queryInsert);

      ////////////////////////////////////////////////////////
      // Reducir existencias en el catlogo
      ////////////////////////////////////////////////////////
      $queryUpdate =
         "UPDATE Libros
             SET
                Existencias = (Existencias - ".$b[$i]['Unidades'].")
             WHERE
                LibroID = \"".$b[$i]['LibroID']."\" AND
                Existencias >= ".$b[$i]['Unidades'].";";

       if (!$con->query($queryUpdate))
	         tratarError("Error en modificacin de tabla de libros", $queryUpdate);

       if ($con->affected_rows == 0) {
          ////////////////////////////////////////////////////////
          // saca el mensaje pero sigue el proceso para verificar
          // las existencias de todos los libros solicitados
          ////////////////////////////////////////////////////////
          echo "<br>No se confirma el pedido.<br>";
          echo "<br>No hay suficientes existencias del libro ". $b[$i]['LibroID']."<br>";
          $nok= "nok";
        }
        else {

        ////////////////////////////////////////////////////////////////
        //
        // aqu se debera insertar la funcin de proceso de la tarjeta
        // de crdito
        //
        ////////////////////////////////////////////////////////////////

        }

}

if ($nok=="nok")  {
     ////////////////////////////////////////////////////////////
     // retrocede todas las actualizaciones de la transaccin
     ////////////////////////////////////////////////////////////

     $con->rollback();

   }
else  {
     ////////////////////////////////////////////////////////////
     // Borrado de la cesta y del tem de la cesta
     ////////////////////////////////////////////////////////////
     $queryDelete=
        "DELETE FROM ItemCesta
           WHERE
             CestaID = \"".$cesta."\";";


      if (!$con->query($queryDelete))
           tratarError("Error en eliminacin de tabla de ItemCesta:", $queryDelete);

     $queryDelete=
        "DELETE FROM Cesta
           WHERE
             CestaID = \"".$cesta."\";";


      if (!$con->query($queryDelete))
           tratarError("Error en eliminacin de tabla de cesta:", $queryDelete);

     ////////////////////////////////////////////////////////////
     // confirma las actualizaciones de la transaccin
     ////////////////////////////////////////////////////////////

     $con->commit();


     /////////////////////////////////////////////////////////////
     // Email al comprador
     /////////////////////////////////////////////////////////////
     $to = $fcli['EMail'];
	 $subject = "Confirmacin de compra";
	 $body = "<html><head><title>Confirmacin de compra en librera Comercio </title></head>";
	 $body .= "<body>Su pedido tiene el nmero ".$PedidoID."<br><br>";
	 $body .= "Cualquier problema enve un email soporte@libreriacomercio.xxx</body></html>";
	 $header = "MIME-Version: 1.0\n";
	 $header .= "Content-type: text/html; charset=iso-8859-1\n";
	 $header .= "From: Comercio <soporte@libreriacomercio.xxx>\r\n";
	 mail($to, $subject, $body, $header);


	 /////////////////////////////////////////////////////////////
	 // Email a los proveedores para la reposicin de los libros
	 /////////////////////////////////////////////////////////////
	 for($i=0; $i<count($b);$i++) {

	     $to = $b[$i]['EMailProv'];
	 	 $subject = "Pedido de reposicin de libros en librera Comercio";
	 	 $body = "<html><head><title>Confirmacin de compra en librera Comercio </title></head>";
	 	 $body .= "<body>Solicitamos  ".$b[$i]['Unidades']." unidades del libro ";
	 	 $body .= $b[$i]['LibroID']. "<br><br>";
	 	 $body .= "Cualquier problema enve un email soporte@libreriacomercio.xxx</body></html>";
	 	 $header = "MIME-Version: 1.0\n";
	 	 $header .= "Content-type: text/html; charset=iso-8859-1\n";
	 	 $header .= "From: Comercio <soporte@libreriacomercio.xxx>\r\n";

	     mail($to, $subject, $body, $header);

	 }
	 unset($_SESSION['Cesta']);
	 echo "<br><b>Pedido en trmite de envo.</b><br>";
   }


?>
</body>
</html>