<?php
// archivo: revisardatos.php
// objetivo: datos del cliente

// esta pantalla tiene tres partes:
// 1) datos del cliente
// 2) datos de la compra
// 3) eleccin del tipo de envo (con diferentes tarifas)

// Esta pgina lo nico que actualiza es el tipo de envo de la cesta
// el resto slo muestra la informacin y coloca enlaces a diversas partes
// de la aplicacin.
// Desde esta pgina se puede ir a:
// 1) seguir comprando
// 2) cambiar datos personales del cliente
// 3) cambiar datos de la cesta
// 4) cambiar tipo de envo (se hace en esta misma pgina)
// 5) confirmar la compra

////////////////////////////////////////////////////
// archivos de inclusin
////////////////////////////////////////////////////

  include '../include/clTablaHTML.php';
  include '../include/partecomun.php';

$tit= "Datos del cliente ";
?>

<html>
  <head>
    <title><?php echo $tit. "(pgina:".$doc .")" ?></title>
    </head>
    <body>
    <link href="../css/comercio.css"
          rel="stylesheet"
          media="all"
          type="text/css"
           />

<?php

//verVariables();

////////////////////////////////////////////////////
// Se establece la conexin
////////////////////////////////////////////////////
conectarGuest();

////////////////////////////////////////////////////
// Barra de navegacin del proceso de compra
////////////////////////////////////////////////////
tabNavegaCompra();


////////////////////////////////////////////////////
// Si no est en sesin debe autenticarse
////////////////////////////////////////////////////
if (!isset($_SESSION['Cliente']))
    redirect("autenticarse.php");

////////////////////////////////////////////////////
// Si no hay cesta activa vuelve al inicio
////////////////////////////////////////////////////
if (!isset($_SESSION['Cesta']))
	redirect("inicio.php");


$cliente= $_SESSION['Cliente'];
////////////////////////////////////////////////////
// Rutina de actualizacin del tipo de envo
////////////////////////////////////////////////////


if ($_POST["Envo"]=="Cambiar")
{
  $queryUpdate=
    "UPDATE Cesta
       SET
         TipoEnvio = \"".$_POST['Correo']."\"
       WHERE
         CestaID = \"".$_SESSION["Cesta"]."\";";

  if (!$con->query($queryUpdate))
         tratarError("Error en modificacin de tabla de cesta", $queryUpdate);

}

////////////////////////////////////////////////////
// Obtener datos del cliente
////////////////////////////////////////////////////

$strsql =
  "SELECT * FROM Clientes
    WHERE ClienteID =".$cliente.";";

$result= $con->query($strsql);
if (!$result)
       tratarError("Error en lectura de clientes",
                    $strsql);


////////////////////////////////////////////////////
// Mostrar todos los datos actuales del cliente
////////////////////////////////////////////////////

$fila = $result->fetch_assoc();

// detecta el uso de escape en campos alfabticos
if (get_magic_quotes_gpc())  {
   $fila['Nombre']=stripslashes($fila['Nombre']);
   $fila['Apellidos']=stripslashes($fila['Apellidos']);
   $fila['EMail']=stripslashes($fila['EMail']);
   $fila['PalabraPaso']=stripslashes($fila['PalabraPaso']);
   $fila['Direccion']=stripslashes($fila['Direccion']);
   $fila['Ciudad']=stripslashes($fila['Provincia']);
   $fila['CodigoPostal']=stripslashes($fila['CodigoPostal']);
   $fila['Telefono']=stripslashes($fila['Telefono']);
   $fila['FAX']=stripslashes($fila['FAX']);
   $fila['NumeroTarjeta']=stripslashes($fila['NumeroTarjeta']);
   $fila['NombreEntarjeta']=stripslashes($fila['NombreEntarjeta']);
 }

// tabla principal de los datos del cliente
echo "<table valign=\"top\" width=\"100%\" border=\"3\">";
echo "<tr>";

// tabla de la izquierda de la pantalla
echo "<td><table valign=\"top\" width=\"100%\" border=\"1\">";
echo "<tr><td  valign=\"top\">Nombre:</td><td><b>".$fila['Nombre']."</b></td></tr>";
echo "<tr><td>Apellidos: </td><td><b>".$fila['Apellidos']."</b></td></tr>";
echo "<tr><td>Email: </td><td>".$fila['EMail']."</td></tr>";
echo "<tr><td>Palabra de paso:</td><td>********</td></tr>";
echo "<tr><td>Direccin: </td><td>".$fila['Direccion']."</td></tr>";
echo "<tr><td>Ciudad: </td><td>".$fila['Ciudad']."</td></tr>";
echo "<tr><td>Provincia: </td><td>".$fila['Provincia']."</td></tr>";
echo "<tr><td>Cdigo postal: </td><td>".$fila['CodigoPostal']."</td></tr>";
// fin tabla de la izquierda
echo "</table></td>";

// tabla de la derecha de la pantalla
echo "<td><table valign=\"top\" width=\"100%\" border=\"1\">";
echo "<tr><td>Telfono: </td><td>".$fila['Telefono']."</td></tr>";
echo "<tr><td>Fax:</td><td>".$fila['FAX']."</td></tr>";
echo "<tr><td>Tipo de tarjeta:</td><td>";
$tipos=Array("1"=>"VISA","2"=>"MASTER","3"=>"AMERICAN");

while($temp = each($tipos))    {
     if ($temp[1]==$fila['TipoTarjeta'])
         echo $temp[0];
}
echo "</td></tr>";
echo "<tr><td>Nmero de tarjeta: </td><td>".$fila['NumeroTarjeta']."</td></tr>";
echo "<tr><td>Nombre en tarjeta: </td><td>".$fila['NombreEntarjeta']."</td></tr>";
echo "<tr><td>Fecha de caducidad: </td><td>".$fila['FechaCaducidad']."</td></tr>";
echo "<tr><td>Acepta cookies: </td><td>".$fila['AceptaCookies']."</td></tr>";
echo "<tr><td>Suscriptor: </td><td>".$fila['Suscriptor']."</td></tr>";
// fin de la tabla de la derecha
echo "</table></td></tr>";

// fin de la tabla principal
echo "</table>";

// fin 1ra. parte de la pantalla

//////////////////////////////////////////////////////////
// Listado del contenido de la cesta
//////////////////////////////////////////////////////////

$strsql =
  "SELECT ItemCestaID,
          ItemCesta.LibroID,
          CantidadUnidades,
          Nombre,
          Autor,
          Precio,
          IVA,
          Peso
      FROM ItemCesta
      JOIN
         Libros ON ItemCesta.LibroID=Libros.LibroID
      WHERE
         CestaID =".$_SESSION["Cesta"].";";

$result = $con->query($strsql);

if (!$result)
       tratarError("Error en lectura de item de cesta",
                    $strsql);


echo "<h3><center>Datos de la cesta</center></h3>";

// Para esta tabla simple utilizaremos nuestro objeto TablaHTML

// Crea un objeto TablaHTML
$tab2 = new  TablaHTML("Comercio");

// Coloca los ttulos de las columnas
$tab2->asignar_titulos_columnas(
            "ISBN",
            "Ttulo",
            "Autor",
            "Precio unidad",
            "Cantidad unidades",
            "Total en euros",
            "Peso unidad",
            "Peso total en kg.");

// Formularios para la eliminacin y modificacin de item de cesta
$i=1;
$acumPrecio=0;
$acumPeso=0;

while ($fila = $result->fetch_assoc()) {
  // detecta el uso de escape en campos alfabticos
  if (get_magic_quotes_gpc())   {
     $fila['LibroID']=stripslashes($fila['LibroID']);
     $fila['Nombre']=stripslashes($fila['Nombre']);
     $fila['Autor']=stripslashes($fila['Autor']);
  }

  unset($b);
  $b[] = $i++;
  $b[] = $fila['LibroID'];
  $b[] = $fila['Nombre'];
  $b[] = $fila['Autor'];
  $b[] = $fila['Precio']+$fila['IVA'];
  $b[] = $fila['CantidadUnidades'];
  $sumPrecio =  ($fila['Precio']+$fila['IVA'])*$fila['CantidadUnidades'];
  $b[] = $sumPrecio;
  $b[] = $fila['Peso'];
  $sumPeso = $fila['Peso']*$fila['CantidadUnidades'];
  $b[] = $sumPeso;
  $acumPrecio = $acumPrecio + $sumPrecio;
  $acumPeso = $acumPeso + $sumPeso;
  $tab2->aadir_fila($b);

}

echo $tab2->retornoHTML();


// fin 2da parte de la pantalla


//////////////////////////////////////////////////////////
// Eleccin del tipo de envo
//////////////////////////////////////////////////////////
echo "<h3><center>Eleccin del tipo de envo</center></h3>";
$strsql =
  "SELECT TipoEnvio
     FROM Cesta
     WHERE
       CestaID =\"".$_SESSION['Cesta']."\";";

$result = $con->query($strsql);

if (!$result)
       tratarError("Error en lectura de cesta",
                    $strsql);


$fila= $result->fetch_assoc();

// Crea un objeto TablaHTML
$tab2 = new  TablaHTML("Comercio");

// Coloca los ttulos de las columnas
$tab2->asignar_titulos_columnas(
              "Precio compra",
              "Tipo de envo ",
              "Peso total en kg.",
              "Gastos de envo",
              "Total en euros",
              "",
              "Cambiar tipo");


if ($fila['TipoEnvio']=="Correo") $cambiar=2;
else    $cambiar = 1;

// funcin tarifaEnvio calcula el gasto de envo en base al peso
// esto podra tomar en cuenta tambin si es un envo local
// o interprovincial, simple o urgente, etc.

$gastosenvio=tarifaEnvio($acumPeso,$fila['TipoEnvio']);

// limpiar la matriz $b
unset($b);
$b[]="<form method=\"POST\" action=\"".$doc."\" enctype=\"multipart/form-data\">1";
$b[]=$acumPrecio;
$b[]=$fila['TipoEnvio'];
$b[]=$acumPeso;
$b[]=$gastosenvio;
$b[]=$acumPrecio+$gastosenvio;
$b[]="<input type=\"hidden\" name=\"Correo\" value=\"".$cambiar."\">";
$b[]="<input type=\"submit\" name=\"Envo\" value=\"Cambiar\"></form>";
$tab2->aadir_fila($b);

echo $tab2->retornoHTML();

// libera el conjunto de resultados
$result->free_result();

?>
</body>
</html>


