<?php

interface ItemtablaHTML {
  public function retornoHTML();
}


class TablaHTML implements ItemTablaHTML {
  public $mat_tcol; 			// lista de ttulo de columnas
  public $mat_tfil; 			// lista de ttulo de filas
  public $mat_tab; 			    // lista de filas

  public $tabestilocss="";  		    // estilo css
  private $bTituloFila=FALSE; 		// ttulo de filas
  private $bTituloColumna=FALSE;  	// Ttulos de columnas
  private $btabestilocss=FALSE;  		// estilo

  private $indice_lin=1;            // ndice para carga de lneas


  // constructor de la clase TablaHTML
  public function __construct($varestilo="")   {
    if ($varestilo!="")      {
      $this->tabestilocss=$varestilo;
      $this->btabestilocss=TRUE;
    }
  }


  // mtodo para asignar ttulos a las columnas
  // de la tabla
  public function asignar_titulos_columnas()   {
    $numargs = func_num_args();

    for ($i=0;$i<$numargs;$i++)  {
      $this->mat_tcol[$i]=func_get_arg($i);
    }
    $this->bTituloColumna=TRUE;
  }


  // mtodo para asignar ttulos a las filas
  // de la tabla
  public function asignar_titulos_filas($titfila)   {
    // contar la cantidad de elementos
    $numargs = sizeof($titfila);

    $this->mat_tfil[0]="";
    for ($i=0;$i<$numargs;$i++) {
      $this->mat_tfil[$i]=$titfila[$i];
    }

    $this->bTituloFila=TRUE;
  }


  // mtodo para aadir filas
  public function aadir_fila($line)   {
      $this->mat_tab[$this->indice_lin]=$line;
      $this->indice_lin++;
  }


 public function retornoHTML()   {
    // mtodo para generar el cdigo HTML a partir
    // de los datos almacenados en las matrices
    $codeHTML="";

    // si se ha informado un estilo, se asigna la clase de la tabla
    if ($this->btabestilocss==TRUE)
      $codeHTML.='<table class="'.$this->tabestilocss.'" >';
    else
      $codeHTML.='<table>';

    // Si se han informado cabeceras de ttulo
    if ($this->bTituloColumna==TRUE)  {
        $codeHTML.='<tr><th></th>';
        foreach($this->mat_tcol as $tab_tcol)  {
           if ($tab_tcol == "")   {
               $span++;
           }
           else  {
              $codeHTML.='<th colspan="'.$span.'">'.$tab_tcol.'</th>';
              $span= 1;
           }
        }
        $codeHTML.='</tr>';
    }


    // Informa lneas de la tabla
    $i=0;
    foreach($this->mat_tab as $tab_filas)  {
      // si se han informado ttulos de fila
      if ($this->bTituloFila==TRUE)  {
        $codeHTML.='<tr><th>'.$this->mat_tfil[$i].'</th>';
        $i++;
      }
      // informa la lnea de la tabla
      foreach ($tab_filas as $tab_cel)  {
          $codeHTML.='<td>'.$tab_cel.'</td>';
      }

      // cierre del registro de la tabla
      $codeHTML.='</tr>';
     }

     // final de la tabla
     $codeHTML.='</table>';

     // devuelve la cadena HTML
     return $codeHTML;
   }
}
?>
