<?php
////////////////////////////////////////////
// Versin SQLite
////////////////////////////////////////////
// archivo: mantlibros.php
// objetivo: mantenimiento de libros

// Esta pgina permite realizar el mantenimiento del catlogo
// por lo que slo la utiliza el administrador (autenticado)
// Desde esta pgina se pueden realizar altas, bajas y modificaciones
// del catlogo
// Tambin se incluye un buscador para limitar la lista de libros
// visualizados

////////////////////////////////////////////////////
// archivos de inclusin
////////////////////////////////////////////////////

include '../include/clTablaHTML.php';
include '../include/partecomun.php';


$tit= "Mantenimiento de Libros ";
?>

<html>
  <head>
    <title><?php echo $tit. "(pgina:".$doc .")" ?></title>
    </head>
    <body>
    <link href="../css/comercio.css"
          rel="stylesheet"
          media="all"
          type="text/css"
           />

<?php

//verVariables();

////////////////////////////////////////////////////
// Se establece la conexin
////////////////////////////////////////////////////
// observar que se utiliza conectar() en lugar de conectarGuest()
// para no permitir el acceso a los visitantes
// (slo el administrador autenticado)
////////////////////////////////////////////////////
conectar();

////////////////////////////////////////////////////
// Rutinas de operaciones de actualizacin de una fila
////////////////////////////////////////////////////

// Rutina de insercin de un nuevo libro en el catlogo

if (($_POST["AadirLibro"]=="Aadir")&&($_POST["iLibroID"]!=" ")) {
	$queryInsert ="INSERT INTO Libros(LibroID, DepartamentoID, ";
	$queryInsert.=   "Nombre, DetalleMenor, DetalleMayor, Autor, ";
	$queryInsert.=   "Editorial, Paginas, Cubierta, Tema, Imagen, ";
	$queryInsert.=   "Peso, Precio, IVA, Existencias, ProveedorID) ";
	$queryInsert.=   "VALUES (\"";
	$queryInsert.=    $_POST["iLibroID"]."\",\"";
	$queryInsert.=    $_POST["iDepartamentoID"]."\",\"";
	$queryInsert.=    $_POST["iNombre"]."\",\"";
	$queryInsert.=    $_POST["iDetalleMenor"]."\",\"";
	$queryInsert.=    $_POST["iDetalleMayor"]."\",\"";
	$queryInsert.=    $_POST["iAutor"]."\",\"";
	$queryInsert.=    $_POST["iEditorial"]."\",\"";
	$queryInsert.=    $_POST["iPaginas"]."\",\"";
	$queryInsert.=    $_POST["iCubierta"]."\",\"";
	$queryInsert.=    $_POST["iTema"]."\",\"";
	$queryInsert.=    $_POST["iImagen"]."\",\"";
	$queryInsert.=    $_POST["iPeso"]."\",\"";
	$queryInsert.=    $_POST["iPrecio"]."\",\"";
	$queryInsert.=    $_POST["iIVA"]."\",\"";
	$queryInsert.=    $_POST["iExistencias"]."\",\"";
	$queryInsert.=    $_POST["iProveedorID"]."\");";
	if (!sqlite_query($con,$queryInsert))
	tratarError("Error en insercin de tabla de libros", $queryInsert);
}

// Rutina de modificacin de un libro del catlogo

elseif ($_POST["ModificarLib"]=="Modificar") {
	$queryUpdate = "UPDATE Libros SET DepartamentoID = \"".$_POST["vDepartamentoID"];
	$queryUpdate.= "\", Nombre = \"".$_POST["vNombre"];
	$queryUpdate.= "\", DetalleMenor = \"".$_POST["vDetalleMenor"];
	$queryUpdate.= "\", DetalleMayor = \"".$_POST["vDetalleMayor"];
	$queryUpdate.= "\", Autor = \"".$_POST["vAutor"];
	$queryUpdate.= "\", Editorial = \"".$_POST["vEditorial"];
	$queryUpdate.= "\", Paginas = \"".$_POST["vPaginas"];
	$queryUpdate.= "\", Cubierta = \"".$_POST["vCubierta"];
	$queryUpdate.= "\", Tema = \"".$_POST["vTema"];
	$queryUpdate.= "\", Imagen = \"".$_POST["vImagen"];
	$queryUpdate.= "\", Peso = \"".$_POST["vPeso"];
	$queryUpdate.= "\", Precio = \"".$_POST["vPrecio"];
	$queryUpdate.= "\", IVA = \"".$_POST["vIVA"];
	$queryUpdate.= "\", Existencias = \"".$_POST["vExistencias"];
	$queryUpdate.= "\", ProveedorID = \"".$_POST["vProveedorID"];
	$queryUpdate.= "\" WHERE LibroID = \"".$_POST["vLibroID"]."\";";

	echo $queryDelete;

	if (!sqlite_query($con,$queryUpdate))
	tratarError("Error en modificacin de tabla de libros", $queryUpdate);

}

// Rutina de eliminacin de un libro del catlogo

elseif ($_POST["EliminarLib"]=="Eliminar") {
	// Control de integridad: un libro puede estar en una cesta o en un
	// pedido, en tal caso, no se puede eliminar si previamente no se lo
	// elimina de esas tablas

	if  ((Integridad("ItemCesta","LibroID",$_POST["vLibroID"]))||
	   	(Integridad("ItemPedido","LibroID",$_POST["vLibroID"]))) {
	   	echo "No se puede eliminar. Tiene registros dependientes";
	   	}
	else {
		$queryDelete="DELETE FROM Libros WHERE LibroID = \"".$_POST["vLibroID"]."\";";
		if (!sqlite_query($con,$queryDelete)) {
			tratarError("Error en eliminacin de tabla de libros", $queryDelete);
		}
	}
}

////////////////////////////////////////////////////
// Rutina de filtrado de libros
////////////////////////////////////////////////////
elseif ($_POST["Buscar"]=="Buscar") {
	$strsql="WHERE LibroID Like '%".trim($_POST['Texto'])."%' or ";
	$strsql.="      Nombre Like '%".trim($_POST['Texto'])."%' or ";
	$strsql.="      DetalleMenor Like '%".trim($_POST['Texto'])."%' or ";
	$strsql.="      DetalleMayor Like '%".trim($_POST['Texto'])."%' or ";
	$strsql.="      Autor Like '%".trim($_POST['Texto'])."%' or ";
	$strsql.="      Editorial Like '%".trim($_POST['Texto'])."%' or ";
	$strsql.="      Tema Like '%".trim($_POST['Texto'])."%' or ";
	$strsql.="      Imagen Like '%".trim($_POST['Texto'])."%' or ";
	$strsql.="      DepartamentoID Like '%".trim($_POST['Texto'])."%' or ";
	$strsql.="      ProveedorID Like '%".trim($_POST['Texto'])."%'";
	$texto= " donde aparece el texto ".trim($_POST['Texto']);
}

////////////////////////////////////////////////////
// Rutina de filtrado de libros por proveedor
////////////////////////////////////////////////////
elseif ($_GET["VerProv"]=="Buscar") {
	$strsql="WHERE  ProveedorID = ".trim($_GET['vProveedorID'])." ";
	$texto= " del proveedor ".trim($_GET['vProveedorID']);
}

////////////////////////////////////////////////////
// Rutina de filtrado de libros por departamento
////////////////////////////////////////////////////
elseif ($_GET["VerDepto"]=="Buscar") {
	$strsql="WHERE  DepartamentoID = ".trim($_GET['vDepartamentoID'])." ";
	$texto= " del departamento ".trim($_GET['vDepartamentoID']);
}

////////////////////////////////////////////////////
// Obtener los libros del catlogo
////////////////////////////////////////////////////
$strsql= "SELECT * FROM Libros ".$strsql;

// crea el conjunto de resultados
$result = sqlite_query($con,$strsql);

// si es false, fall la consulta
// no confundir con vaco:
// el conjunto $result puede estar vaco pero eso no produce false
// un conjunto de resultados vaco es una respuesta vlida

if (!$result)  tratarError("Error en lectura de tabla de libros", $strsql);


$cantrows=sqlite_num_rows($result);

echo "<h2><center>".$tit." : sesin: " .$_SERVER['PHP_AUTH_USER']." </center></h2>";


////////////////////////////////////////////////////
// Obtener la lista de departamentos vigentes
////////////////////////////////////////////////////
$strsql = "SELECT * FROM Departamentos ORDER BY Nombre";
$result2 = sqlite_query($con,$strsql);
while ($fila2 = sqlite_fetch_array($result2, SQLITE_ASSOC))
$depto[$fila2['DepartamentoID']]=$fila2['Nombre'];


////////////////////////////////////////////////////
// Obtener la lista de proveedores vigentes
////////////////////////////////////////////////////
$strsql = "SELECT * FROM Proveedores ORDER BY Nombre";
$result3 = sqlite_query($strsql,$con);
while ($fila3= sqlite_fetch_array($result3, SQLITE_ASSOC))
$proveedores[$fila3['ProveedorID']]=$fila3['Empresa'];


////////////////////////////////////////////////////
// enlaces a otras pginas
////////////////////////////////////////////////////

// Tabla de navegacin del administrador del sitio
tabnavega($doc);

echo "(libros listados en esta pantalla $cantrows )<BR>";
echo "<a href=\"#aadir\">Aadir nuevo libro</a>";

////////////////////////////////////////////////////
// Obtiene las imgenes disponibles en la carpeta images
////////////////////////////////////////////////////
$dir = dirname($_SERVER['SCRIPT_FILENAME'])."/images";
$var = opendir($dir);

while ($file = readdir($var)) $imags[]= $file;


////////////////////////////////////////////////////
// Matriz con los tipos de cubiertas
////////////////////////////////////////////////////
$cubs =array("1"=>"Rstica","2"=> "Carton", "3"=>"CD");

////////////////////////////////////////////////////
// Mostrar todos los libros seleccionados
////////////////////////////////////////////////////

while ($fila = sqlite_fetch_array($result, SQLITE_ASSOC)) {
	// detecta el uso de escape
	if (get_magic_quotes_gpc())    {
		$fila['Nombre']=stripslashes($fila['Nombre']);
		$fila['Imagen']=stripslashes($fila['Imagen']);
		$fila['Autor']=stripslashes($fila['Autor']);
		$fila['Editorial']=stripslashes($fila['Editorial']);
		$fila['LibroID']=stripslashes($fila['LibroID']);
		$fila['Tema']=stripslashes($fila['Tema']);
		$fila['DetalleMenor']=stripslashes($fila['DetalleMenor']);
		$fila['DetalleMayor']=stripslashes($fila['DetalleMayor']);
	}
	echo "<form method=\"POST\" action=\"".$doc."\" enctype=\"multipart/form-data\">";
	echo "<table valign=\"top\" width=\"750\" border=\"3\">";
	echo "<tr>";
	echo "<td><table valign=\"top\" width=\"100\" border=\"1\">";
	echo "<tr><td  valign=\"top\">Ttulo:<b><textarea  cols=\"30\" rows=\"4\"  name='vNombre'>".$fila['Nombre']."</textarea></b></td></tr>";
	echo "<tr><td align=\"center\"><img  src=\"../images/".$fila['Imagen']."\" width=\"100\" height=\"170\" alt=\"imagen de la portada del libro\"/></td></tr>";

	echo "<tr><td>Imagen:<select name='vImagen'>";

	foreach($imags as $v) {
		$sel="";
		if ($v==$fila['Imagen']) $sel = "selected=\"selected\"";
		echo "<option value=\"".$v."\"" .$sel.">".$v."</option>";
	}

	echo "</select></td></tr>";
	echo "</table></td>";
	echo "<td><table valign=\"top\" width=\"200\" border=\"0\">";
	echo "<tr><td>Autor: <br><b><input type='text' name='vAutor' value=\"".$fila['Autor']."\"></b></td></tr>";
	echo "<tr><td>Editorial: <br><input type='text' name='vEditorial' value=\"".$fila['Editorial']."\"></td></tr>";
	echo "<tr><td>ISBN: <br>".$fila['LibroID']."<input type='hidden' name='vLibroID' value=\"".$fila['LibroID']."\"></td></tr>";
	echo "<tr><td>Pginas:<br><input type='text' name='vPaginas' value='".$fila['Paginas']."'></td></tr>";

	echo "<tr><td>Cubierta:<br><select name='vCubierta'>";
	reset($cubs);
	while($temp = each($cubs)) {
		$sel="";
		if ($temp[1]==$fila['Cubierta']) $sel = "selected=\"selected\"";
		echo "<option value=\"".$temp[0]."\"" .$sel.">".$temp[1]."</option>";
	}

	echo "</select></td></tr>";
	echo "<tr><td>Peso en kg.: <br><input type='text' name='vPeso' value='".$fila['Peso']."'></td></tr>";
	echo "<tr><td>Precio en euros: <br><input type='text' name='vPrecio' value='".$fila['Precio']."'></td></tr>";
	echo "<tr><td>IVA: <br><input type='text' name='vIVA' value='".$fila['IVA']."'></td></tr>";

	// Select de proveedores
	echo "<tr><td>Proveedor:<br><select name='vProveedorID'>";
	reset($proveedores);
	while($temp = each($proveedores))  {
		$sel="";
		if ($temp[0]==$fila['ProveedorID']) $sel = "selected=\"selected\"";
		echo "<option value=\"".$temp[0]."\"" .$sel.">".$temp[1]."</option>";
	}
	echo "</select></td></tr>";

	echo "<tr><td>Existencias en unidades: <br><input type='text' name='vExistencias' value='".$fila['Existencias']."'></td></tr>";
	echo "</table></td>";
	echo "<td><table valign=\"top\" width=\"450\" border=\"1\">";

	// Select de departamentos
	echo "<tr><td>Departamento:<select name='vDepartamentoID'>";
	reset($depto);
	while($temp = each($depto)) {
		$sel="";
		if ($temp[0]==$fila['DepartamentoID']) $sel = "selected=\"selected\"";
		echo "<option value=\"".$temp[0]."\"" .$sel.">".$temp[1]."</option>";
	}
	echo "</select></td></tr>";

	echo "<tr><td>Tema: <input type='text' name='vTema' value=\"".$fila['Tema']."\"></td></tr>";
	echo "<tr><td>Resumen: <textarea  cols=\"50\" rows=\"5\" name='vDetalleMenor'>".$fila['DetalleMenor']."</textarea></td></tr>";
	echo "<tr><td>Detalle: <textarea  cols=\"50\" rows=\"15\" name='vDetalleMayor'>".$fila['DetalleMayor']."</textarea></td></tr>";
	echo "</table></td></tr>";
	echo "</table>";

	// Botones submit
	echo "<input type=\"submit\" name=\"EliminarLib\" value=\"Eliminar\">";
	echo "<input type=\"submit\" name=\"ModificarLib\" value=\"Modificar\">";
	echo "</form>";

}

////////////////////////////////////////////////////
// Formulario de insercin de nuevos libros
////////////////////////////////////////////////////
echo "<a name=\"aadir\"></a>";
echo "<form method=\"POST\" action=\"".$doc."\" enctype=\"multipart/form-data\">";
echo "<table valign=\"top\" width=\"750\" border=\"3\">";
echo "<tr>";
echo "<td><table valign=\"top\" width=\"100\" border=\"1\">";
echo "<tr><td  valign=\"top\">Ttulo:<b><textarea  cols=\"30\" rows=\"4\"  name='iNombre'></textarea></b></td></tr>";

// Select de imgenes
echo "<tr><td>Imagen:<select name='iImagen'>";
foreach($imags as $v)
echo "<option value=\"".$v."\">".$v."</option>";
echo "</select></td></tr>";

echo "</table></td>";
echo "<td><table valign=\"top\" width=\"200\" border=\"0\">";
echo "<tr><td>Autor: <br><b><input type='text' name='iAutor' value=''></b></td></tr>";
echo "<tr><td>Editorial: <br><input type='text' name='iEditorial' value=''></td></tr>";
echo "<tr><td>ISBN: <br><input type='text' name='iLibroID' value=''></td></tr>";
echo "<tr><td>Pginas:<br><input type='text' name='iPaginas' value=''></td></tr>";

// Select de tipo de cubierta
echo "<tr><td>Cubierta:<br><select name='iCubierta'>";
reset($cubs);
while($temp = each($cubs))
echo "<option value=\"".$temp[0]."\">".$temp[1]."</option>";
echo "</select></td></tr>";

echo "<tr><td>Peso en kg.: <br><input type='text' name='iPeso' value=''></td></tr>";
echo "<tr><td>Precio en euros: <br><input type='text' name='iPrecio' value=''></td></tr>";
echo "<tr><td>IVA: <br><input type='text' name='iIVA' value=''></td></tr>";

// Select de proveedores
echo "<tr><td>Proveedor:<br><select name='iProveedorID'>";
reset($proveedores);
while($temp = each($proveedores))
echo "<option value=\"".$temp[0]."\"" .$sel.">".$temp[1]."</option>";
echo "</select></td></tr>";

echo "<tr><td>Existencias en unidades: <br><input type='text' name='iExistencias' value=''></td></tr>";
echo "</table></td>";
echo "<td><table valign=\"top\" width=\"450\" border=\"1\">";

// Select de departamentos
echo "<tr><td>Departamento:<select name='iDepartamentoID'>";
reset($depto);
while($temp = each($depto))
echo "<option value=\"".$temp[0]."\"" .$sel.">".$temp[1]."</option>";
echo "</select></td></tr>";

echo "<tr><td>Tema: <input type='text' name='iTema' value=''></td></tr>";
echo "<tr><td>Resumen: <textarea  cols=\"50\" rows=\"5\" name='iDetalleMenor'></textarea></td></tr>";
echo "<tr><td>Detalle: <textarea  cols=\"50\" rows=\"15\" name='iDetalleMayor'></textarea></td></tr>";
echo "</table></td></tr>";
echo "</table>";
echo "<input type=\"submit\" name=\"AadirLibro\" value=\"Aadir\">";
echo "</form>";

?>
</body>
</html>