<?php
print "<B><U>Creacin del resto de las tablas de la base de datos Comercio (ejemplo c1404.php)</U></B><BR><BR>";

// Apertura de una base de datos Comercio
$db1 = sqlite_open('Datos/Comercio', 0666, $sqliteerror);

// Elimina las tablas (por precaucin)
@sqlite_query($db1, 'DROP TABLE Clientes;');
@sqlite_query($db1, 'DROP TABLE Cesta;');
@sqlite_query($db1, 'DROP TABLE ItemCesta;');
@sqlite_query($db1, 'DROP TABLE Pedidos;');
@sqlite_query($db1, 'DROP TABLE ItemPedido;');
@sqlite_query($db1, 'DROP TABLE Cuentas;');

// Comienza la transaccin
sqlite_query($db1,"BEGIN");

//*=====================*/
//* Tabla Clientes      */
//*=====================*/
$creat1 = "CREATE TABLE Clientes (
 			ClienteID INTEGER PRIMARY KEY NOT NULL,
			Nombre VARCHAR(32) NOT NULL DEFAULT ' ',
            Apellidos 	VARCHAR(25) NOT NULL,
            EMail  	VARCHAR(50) NOT NULL,
            PalabraPaso  	VARCHAR(16),
            AceptaCookies	VARCHAR(1),
            Suscriptor	VARCHAR(1),
            Direccion  	VARCHAR(50) NOT NULL,
            Ciudad  	VARCHAR(50) NOT NULL,
            Provincia  	VARCHAR(50),
            CodigoPostal	VARCHAR(10),
            Telefono 	VARCHAR(20),
            FAX 		VARCHAR(20),
            TipoTarjeta 	VARCHAR(10) NOT NULL,
            NumeroTarjeta 	VARCHAR(20),
            NombreEntarjeta VARCHAR(50),
            FechaCaducidad	TIMESTAMP,
            LimiteCredito	DOUBLE(12,2) ,
            UltimaMod	TIMESTAMP,
            FechaCreacion	TIMESTAMP);";

// Ejecucin del query
sqlite_query($db1,$creat1 );

// Creacin de un ndice sobre Nombre
$creai1 = "CREATE INDEX ind_Apellidos ON Clientes (Apellidos);";

//*=====================*/
//* Tabla Cesta         */
//*=====================*/
$creat1 = "CREATE TABLE Cesta (
           CestaID 	INTEGER PRIMARY KEY NOT NULL,
           ClienteID 	INTEGER,
           FechaCreacion 	TIMESTAMP,
           TipoEnvio	VARCHAR(10),
           MedioPago 	VARCHAR(10));";

// Ejecucin del query
sqlite_query($db1,$creat1 );

//*=====================*/
//* Tabla ItemCesta     */
//*=====================*/
$creat1 = "CREATE TABLE ItemCesta (
           ItemCestaID 	INTEGER PRIMARY KEY NOT NULL,
           CestaID 	INTEGER,
           LibroID      VARCHAR(16),
           CantidadUnidades	INTEGER NOT NULL DEFAULT '0');";

// Ejecucin del query
sqlite_query($db1,$creat1 );

//*=====================*/
//* Tabla Pedidos       */
//*=====================*/
$creat1 = "CREATE TABLE Pedidos (
 			PedidoID INTEGER PRIMARY KEY NOT NULL,
 			ClienteID INTEGER NOT NULL,
 			FechaPedido TIMESTAMP,
			Nombre VARCHAR(32) NOT NULL DEFAULT ' ',
            Apellidos 	VARCHAR(25) NOT NULL,
            EMail  	VARCHAR(50) NOT NULL,
            Direccion  	VARCHAR(50) NOT NULL,
            Ciudad  	VARCHAR(50) NOT NULL,
            Provincia  	VARCHAR(50),
            Pais  	VARCHAR(50),
            CodigoPostal	VARCHAR(10),
            Telefono 	VARCHAR(20),
            FAX 		VARCHAR(20),
            TipoTarjeta 	VARCHAR(10) NOT NULL,
            NumeroTarjeta 	VARCHAR(20),
            NombreEntarjeta VARCHAR(50),
            FechaCaducidad	TIMESTAMP,
            TipoEnvio 	VARCHAR(10) DEFAULT 'Correo',
			MedioPago 	VARCHAR(10) DEFAULT ' Tarjeta',
			PesoEnvio 	DOUBLE(12,2)  NOT NULL DEFAULT '0',
			GastosEnvio	DOUBLE(12,2) NOT NULL DEFAULT '0',
			PrecioSinIVA   DOUBLE(12,2)  NOT NULL DEFAULT '0',
			IVA 		DOUBLE(12,2)  NOT NULL DEFAULT '0',
			TotalCargo	DOUBLE(12,2)  NOT NULL DEFAULT '0',
			Estado 	VARCHAR(15) DEFAULT 'En proceso',
			FechaEstado    TIMESTAMP,
			FechaEnvio 	TIMESTAMP,
  			RefEnvio	VARCHAR(255) DEFAULT NULL);";

// Ejecucin del query
sqlite_query($db1,$creat1 );

//*=====================*/
//* Tabla ItemPedido     */
//*=====================*/
$creat1 = "CREATE TABLE ItemPedido (
           ItemPedidoID 	INTEGER PRIMARY KEY NOT NULL,
           PedidoID 	INTEGER,
           LibroID      VARCHAR(16),
           Unidades	INTEGER NOT NULL DEFAULT '0',
		   PesoTotal 	DOUBLE(12,2)  NOT NULL DEFAULT '0',
		   PrecioTotal 	DOUBLE(12,2)  NOT NULL DEFAULT '0',
		   IVATotal 	DOUBLE(12,2)  NOT NULL DEFAULT '0',
		   PrecioVP 	DOUBLE(12,2)  NOT NULL DEFAULT '0');";


// Ejecucin del query
sqlite_query($db1,$creat1 );

//*=====================*/
//* Tabla Cuentas     */
//*=====================*/
$creat1 = "CREATE TABLE Cuentas (
           Login 	  VARCHAR(16),
           PalabraPaso	VARCHAR(16)); ";


// Ejecucin del query
sqlite_query($db1,$creat1 );


// Confirma las actualizaciones
sqlite_query($db1,"COMMIT;");

print "<BR>En la tabla Clientes de la base de datos Comercio hay " .
       sqlite_fetch_single(sqlite_query($db1, "SELECT COUNT(*) FROM Clientes;")) .
	   " registros<BR>";
print "<BR>En la tabla Cesta de la base de datos Comercio hay " .
       sqlite_fetch_single(sqlite_query($db1, "SELECT COUNT(*) FROM Cesta;")) .
	   " registros<BR>";
print "<BR>En la tabla ItemCesta de la base de datos Comercio hay " .
       sqlite_fetch_single(sqlite_query($db1, "SELECT COUNT(*) FROM ItemCesta;")) .
	   " registros<BR>";
print "<BR>En la tabla Pedidos de la base de datos Comercio hay " .
       sqlite_fetch_single(sqlite_query($db1, "SELECT COUNT(*) FROM Pedidos;")) .
	   " registros<BR>";
print "<BR>En la tabla ItemPedido de la base de datos Comercio hay " .
       sqlite_fetch_single(sqlite_query($db1, "SELECT COUNT(*) FROM ItemPedido;")) .
	   " registros<BR>";
print "<BR>En la tabla Cuentas de la base de datos Comercio hay " .
       sqlite_fetch_single(sqlite_query($db1, "SELECT COUNT(*) FROM Cuentas;")) .
	   " registros<BR>";


?>